<!-- SHIELDS -->
[![Contributors][contributors-shield]][contributors-url]
[![Stars][stars-shield]][stars-url]
[![Forks][forks-shield]][forks-url]
[![Issues][issues-shield]][issues-url]


# Centreon Stream Connectors #

Centreon stream connectors are LUA scripts that help you send your Centreon monitoring datas to your favorite tools

# Stream connectors

Available scripts

Here is a list of the Centreon powered scripts:

| Software | Connectors | Documentations |
| -------- | ---------- | -------------- |
| BSM      | [BSM Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/bsm) | [Documentation](https://docs.centreon.com/current/en/integrations/event-management/sc-hp-bsm.html) |
| ElasticSearch | [ElasticSearch Stream Connectors](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/elasticsearch) | [Events Documentation](https://docs.centreon.com/current/en/integrations/data-analytics/sc-elastic-events.html), [Metrics Documentation](https://docs.centreon.com/current/en/integrations/data-analytics/sc-elastic-metrics.html) |
| InfluxDB | [InfluxDB Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/influxdb) | WIP |
| NDO | [NDO Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/ndo) | [Documentation](https://docs.centreon.com/current/en/integrations/stream-connectors/ndo.html) |
| OMI | [OMI Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/omi) | [Documentation](https://docs.centreon.com/current/en/integrations/event-management/sc-hp-omi.html) |
| Opsgenie | [Opsgenie Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/opsgenie) | [Documentation](https://docs.centreon.com/current/en/integrations/event-management/sc-opsgenie.html) |
| PagerDuty | [PagerDuty Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/pagerduty) | [Documentation](https://docs.centreon.com/current/en/integrations/event-management/sc-pagerduty-events.html) |
| Prometheus | [Prometheus Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/prometheus) | WIP |
| ServiceNow | [ServiceNow Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/servicenow) | [Documentation](https://docs.centreon.com/current/en/integrations/event-management/sc-service-now-events.html) |
| Signl4 | [Signl4 Stream Connectors](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/signl4) | [Events Documentation](https://docs.centreon.com/current/en/integrations/event-management/sc-signl4-events.html) |
| Splunk | [Splunk Stream Connectors](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/splunk) | [Events Documentation](https://docs.centreon.com/current/en/integrations/data-analytics/sc-splunk-events.html), [Metrics Documentation](https://docs.centreon.com/current/en/integrations/data-analytics/sc-splunk-metrics.html) |
| Warp10 | [Warp10 Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/centreon-certified/warp10) | [Documentation](https://docs.centreon.com/current/en/integrations/data-analytics/sc-warp10.html) |

Here is a list of the Community powered scripts

| Software | Connectors | Documentations | Contributors | Organizations |
| -------- | ---------- | -------------- | ------------ | ------------- |
| Canopsis | [Canopsis Stream Connector](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/community-powered/canopsis) | [Documentation](https://github.com/centreon/centreon-stream-connector-scripts/tree/master/community-powered/canopsis/README.md) | [ppremont-capensis](https://github.com/ppremont-capensis) | [Capensis](https://www.capensis.fr/en/) |

# Contribute

If you wish to help us improve this project, feel free to read the [Contribute.md](https://github.com/centreon/centreon-stream-connector-scripts/blob/master/CONTRIBUTE.md) file.


<!-- URL AND IMAGES FOR SHIELDS -->
[contributors-shield]: https://img.shields.io/github/contributors/centreon/centreon-stream-connector-scripts?color=%2384BD00&label=CONTRIBUTORS&style=for-the-badge
[stars-shield]: https://img.shields.io/github/stars/centreon/centreon-stream-connector-scripts?color=%23433b02a&label=STARS&style=for-the-badge
[forks-shield]: https://img.shields.io/github/forks/centreon/centreon-stream-connector-scripts?color=%23009fdf&label=FORKS&style=for-the-badge
[issues-shield]: https://img.shields.io/github/issues/centreon/centreon-stream-connector-scripts?color=%230072ce&label=ISSUES&style=for-the-badge

[contributors-url]: https://github.com/centreon/centreon-stream-connector-scripts/graphs/contributors
[forks-url]: https://github.com/centreon/centreon-stream-connector-scripts/network/members
[stars-url]: https://github.com/centreon/centreon-stream-connector-scripts/stargazers
[issues-url]: https://github.com/centreon/centreon-stream-connector-scripts/issues
